function  [path, D]  = Compute( Map, dim ,ORIGI)

path=zeros(dim); %Store to the shortest parent node of the current node (there may be multiple such parent nodes, so multidimensional array is needed to store)
D=zeros(1,dim); %Store he shortest distance to the current node (this value is unique, so only one-dimensional array is needed to store it)
fb=zeros(1,dim);

%initialization:
fb(ORIGI)=1; % fb stores the nodes in the "group", and the starting point is already in the "group"
for i=1:dim %The first D is the distance from the starting point to the neighbors
    D(i)=Map(ORIGI,i);
    path(1,i)=ORIGI;
end
path(1,ORIGI)=0;

while(sum(fb)~=dim) %As long as fb is not full of all nodes, the loop will continue
    min=inf;
    for k=1:dim %looking for the neighbor nodes of the current node (not those in the "group"), and make the node with the smallest distance be in the "group"
        if (fb(k)~=1)&&D(k)<min
            v=k;
            min=D(k);
        end
    end
    fb(v)=1; % be in the "group"
    for k=1:dim % Probe all the neighbors of "v" who just joined the group. The shortest one update to D
        if (fb(k)~=1)&& (min + Map(v,k) < D(k)&& Map(v,k)~=inf)
            D(k)=min + Map(v,k);
            path(:,k)=0;
            path(1,k)=v;
        elseif (fb(k)~=1)&& (min + Map(v,k) == D(k))&& Map(v,k)~=inf %Trigger this if, indicating that there is more than one shortest path to the current node
            D(k)=min + Map(v,k);
            
            pink=1;
            while(1)
                if(path(pink,k)==0) %If there is no data in the current position, assign the value
                    path(pink,k)=v;
                    break;
                else %If there is data in the current position, move to the next column, and the next cycle will try to assign value in the next column
                    pink=pink+1;
                end
            end
        end
    end
    
end

end